/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import {exists, mapValues} from '../runtime';
import {
  NetworkAccountDto,
  NetworkAccountDtoFromJSON,
  NetworkAccountDtoFromJSONTyped,
  NetworkAccountDtoToJSON,
} from './NetworkAccountDto';
import {
  ProofMetricsDto,
  ProofMetricsDtoFromJSON,
  ProofMetricsDtoFromJSONTyped,
  ProofMetricsDtoToJSON,
} from './ProofMetricsDto';
import {
  TransactionMessageStats,
  TransactionMessageStatsFromJSON,
  TransactionMessageStatsFromJSONTyped,
  TransactionMessageStatsToJSON,
} from './TransactionMessageStats';
import {
  TransactionStats,
  TransactionStatsFromJSON,
  TransactionStatsFromJSONTyped,
  TransactionStatsToJSON,
} from './TransactionStats';

/**
 *
 * @export
 * @interface TransactionAllMetrics
 */
export interface TransactionAllMetrics {
  /**
   *
   * @type {TransactionStats}
   * @memberof TransactionAllMetrics
   */
  sentTransactionStats: TransactionStats;
  /**
   *
   * @type {TransactionStats}
   * @memberof TransactionAllMetrics
   */
  receivedTransactionStats: TransactionStats;
  /**
   *
   * @type {TransactionMessageStats}
   * @memberof TransactionAllMetrics
   */
  transactionMessagesStats: TransactionMessageStats;
  /**
   *
   * @type {ProofMetricsDto}
   * @memberof TransactionAllMetrics
   */
  proofMetrics?: ProofMetricsDto;
  /**
   *
   * @type {NetworkAccountDto}
   * @memberof TransactionAllMetrics
   */
  networkAccount?: NetworkAccountDto;
}

export function TransactionAllMetricsFromJSON(
  json: any
): TransactionAllMetrics {
  return TransactionAllMetricsFromJSONTyped(json, false);
}

export function TransactionAllMetricsFromJSONTyped(
  json: any,
  ignoreDiscriminator: boolean
): TransactionAllMetrics {
  if (json === undefined || json === null) {
    return json;
  }
  return {
    sentTransactionStats: TransactionStatsFromJSON(
      json['sentTransactionStats']
    ),
    receivedTransactionStats: TransactionStatsFromJSON(
      json['receivedTransactionStats']
    ),
    transactionMessagesStats: TransactionMessageStatsFromJSON(
      json['transactionMessagesStats']
    ),
    proofMetrics: !exists(json, 'proofMetrics')
      ? undefined
      : ProofMetricsDtoFromJSON(json['proofMetrics']),
    networkAccount: !exists(json, 'networkAccount')
      ? undefined
      : NetworkAccountDtoFromJSON(json['networkAccount']),
  };
}

export function TransactionAllMetricsToJSON(
  value?: TransactionAllMetrics | null
): any {
  if (value === undefined) {
    return undefined;
  }
  if (value === null) {
    return null;
  }
  return {
    sentTransactionStats: TransactionStatsToJSON(value.sentTransactionStats),
    receivedTransactionStats: TransactionStatsToJSON(
      value.receivedTransactionStats
    ),
    transactionMessagesStats: TransactionMessageStatsToJSON(
      value.transactionMessagesStats
    ),
    proofMetrics: ProofMetricsDtoToJSON(value.proofMetrics),
    networkAccount: NetworkAccountDtoToJSON(value.networkAccount),
  };
}
